<?php defined('BASEPATH') || exit('No direct script access allowed');

class User extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->library('form_validation');
        $this->load->helper('form');
        $this->load->library('session');
        $this->load->model('muser');
        $this->load->model('counter_model');
    }
    public function login(){
        
            $user_id = $this->input->post('user_id');
            $password = '';
            if($this->input->post('password') != ''){
                $password = $this->input->post('password');
            }
            if($user_id){
                $record = $this->muser->login($user_id, $password);
           
                if(count($record) == 0){
                        $this->session->set_flashdata('error_message', 'User ID or password is incorrect!');
                }else{
                    foreach($record as $val){
                        $this->session->set_userdata('user_id', $val['user_id']);
                        $this->session->set_userdata('type', $val['type']);
                        $type = $val['type'];
                        if($type == 'patient'){
                            redirect(base_url().'patient');
                        }elseif($type == 'doctor'){
                            redirect(base_url().'doctor');
                        }else{
                            redirect(base_url());
                        }
                        
                    }
                }
            }
           	

        $data['subview'] = 'user/login';
        $this->load->view('layouts/main', $data);
        
    }
    public function logout(){
        $this->session->unset_userdata("user_id");
        $this->session->unset_userdata("type");
        $this->session->unset_userdata("notication");
        $this->session->unset_userdata("choose_patient");
        redirect(base_url().'user/login');
    }
    public function create(){
        $user_login = $this->session->userdata("user_id");
        if($user_login != ''){
            redirect(base_url());
        }
        $this->form_validation->set_rules('user_id', 'User ID', 'required|min_length[6]');
           
        if($this->form_validation->run() != FALSE){
            $uid = $this->input->post('type', true);
            $data = array();
            $data['user_id'] = $this->input->post('user_id', true);
            $data['first_name'] = $this->input->post('first_name', true);
            $data['last_name'] = $this->input->post('last_name', true);
            $data['role'] = $this->input->post('role', true);
            $data['type'] = $this->input->post('type', true);
            
            
            if($this->input->post('doctor_name', true) != ''){
                $data['doctor_name'] = $this->input->post('doctor_name', true);
            }
            if($this->input->post('doctor_address', true) != ''){
                $data['doctor_address'] = $this->input->post('doctor_address', true);
            }
            if($this->input->post('phone_number', true) != ''){
                $data['phone_number'] = $this->input->post('phone_number', true);
            }
            if($this->input->post('license_id', true) != ''){
                $data['license_id'] = $this->input->post('license_id', true);
            }
            if($this->input->post('password', true) != ''){
                $data['password'] = $this->input->post('password', true);
            }
 
			$check = $this->muser->check_create($data['user_id']);
            if(count($check) == 0){
                $id_name = 'users';
                $table = 'counters';
                $id_ai = $this->counter_model->update_ai($id_name, $table);
                $data['UID'] = ($uid == 'patient' ? P.$id_ai : D.$id_ai);
                
                $this->muser->addUser($data);
    			$this->session->set_flashdata('success_message', 'Add user successfully!');
    			redirect(base_url().'user/create');
            }else{
                $this->session->set_flashdata('error_message', 'ID have been available');
                $data['subview'] = 'user/create';
                $this->load->view('layouts/main', $data);
                
            }
			
		}
		
        $data['subview'] = 'user/create';
		$this->load->view('layouts/main', $data);
    }
    
}