<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Doctor_Model extends CI_Model
{

    protected $table_name = 'events';
    protected $db;

    public function __construct()
    {
        parent::__construct();
        $m = new MongoClient('mongodb://quang:quang@cluster0-shard-00-00-lra5a.mongodb.net:27017,cluster0-shard-00-01-lra5a.mongodb.net:27017,cluster0-shard-00-02-lra5a.mongodb.net:27017/admin?ssl=true&replicaSet=Cluster0-shard-0');
        $this->db = $m->selectDB("mydb");

    }
    public function find_all_events_by_type1($recent, $patient_id,  $a_r, $sort, $user_login)
    {
        $collection = $this->db->selectCollection("events");
        $data = $collection->aggregate(array(

            array('$match' => array('$or' => array(
                        array(
                            "type1" => "Hospital Dr Encounter",
                            "date" => array('$gte' => new MongoDate(strtotime($recent))),
                            'patient' => $patient_id != '' ? array('$in' => $a_r) : array('$exists' => true),
                            ),
                        array(
                            "type1" => "Visit",
                            "date" => array('$gte' => new MongoDate(strtotime($recent))),
                            'patient' => $patient_id != '' ? array('$in' => $a_r) : array('$exists' => true),
                            ),
                        array(
                            "type1" => "ER Dr. encounter",
                            "date" => array('$gte' => new MongoDate(strtotime($recent))),
                            'patient' => $patient_id != '' ? array('$in' => $a_r) : array('$exists' => true),
                            ),
                        ), ), ),
            
            
            array('$group' => array(
                    '_id' => array('patient' => '$patient'),
                    'date' => array('$max' => '$date'),

                    )),
            array('$sort' => array('date' => $sort)),


            ));


        $data = $data['result'];
        return $data;
    }
    public function find_all_events($recent, $patient_id, $a_r, $choose_collection_patient,
        $start, $limit, $list_id_by_user_share)
    {
        $collection = $this->db->selectCollection("events");
        $data=$collection->aggregate(array(  
                            
                            array(
                            '$match' => array('$and' => array(
                                array(
                                    "date"=> array('$gte' => new MongoDate(strtotime($recent))),
                                    'patient' => $patient_id != '' ? array('$in' => $a_r) : array('$exists' => true),
                                ),
                                array(
                                    "patient" => array('$in' => $list_id_by_user_share),
                                ),
                                
                            ),),),
                            
        
                            array(
                             '$group'=> 
                                array(
                                '_id'=>array('patient' => '$patient'),
                                'date'=>array('$max'=>'$date'),  
                                'books'=>array('$push' => '$$ROOT'),            
                                     )
                                 ), 
                            
                            array('$lookup' => array(
                                    'from' => $choose_collection_patient,
                                    'localField' => '_id.patient',
                                    'foreignField' => 'patient_random',
                                    'as' => 'name'
                            
                            )) ,
                           array('$skip'=> (int)$start),
                            array('$limit'=> $limit),
                           
                        
                            )                            
                    );
                $data = $data['result'];
                
        return $data;
        
    }
    public function search_patient($choose_collection_patient, $patient_id)
    {
        
        $collection = $this->db->selectCollection($choose_collection_patient);
        $data = $collection->aggregate(array(array('$match' => array('$or' => array(
                        array("patient" => new MongoRegex("/" . $patient_id . "/"), ),
                        array("patient_random" => new MongoRegex("/" . $patient_id . "/"), ),
                        array("first_name" => new MongoRegex("/" . $patient_id . "/"), ),
                        array("last_name" => new MongoRegex("/" . $patient_id . "/"), ),
                        ), ), ), ));

        $data_id = $data['result'];
        
        return $data_id;
    }
    public function count_all($recent, $list_id_by_user_share)
    {
        
        $collection = $this->db->selectCollection("events");
        $nums_total = $collection->aggregate(array(

            array('$match' => array(
                    "date" => array('$gte' => new MongoDate(strtotime($recent))),
                    "patient" => array('$in' => $list_id_by_user_share),

                    ), ),
            array('$group' => array('_id' => array('patient' => '$patient'))),

            array('$group' => array(
                    '_id' => null,
                    'count' => array('$sum' => 1),
                    )),


            ));
            
        return $nums_total;
        
    }
    public function get_all_user_requester($user_login)
    {
        $collection = $this->db->selectCollection("patient_auth");
        $condition = array('requester' => $user_login, 'status' => "1");
        $record = $collection->find($condition);
        $record = iterator_to_array($record);

        return $record;
    }
    public function get_all_user_id_in_user($array_patient_id)
    {

        $collection = $this->db->selectCollection("patient_auth");
        $condition_token = array('user_id' => array('$in' => $array_patient_id),
                'status' => "1");
        $record = $collection->find($condition_token, array('transfer_patient_id'));
        $record = iterator_to_array($record);
        $array_patient_id = array();
        if (count($record) > 0)
        {
            foreach ($record as $val)
            {
                $array_patient_id[] = $val['transfer_patient_id'];
            }
        }

        return $array_patient_id;
    }
}
