<?php

class Token_Model extends CI_Model
{
    protected $db;

    public function __construct()
    {
        $this->load->model('counter_model');
        $m = new MongoClient('mongodb://quang:quang@cluster0-shard-00-00-lra5a.mongodb.net:27017,cluster0-shard-00-01-lra5a.mongodb.net:27017,cluster0-shard-00-02-lra5a.mongodb.net:27017/admin?ssl=true&replicaSet=Cluster0-shard-0');
        $this->db = $m->selectDB("mydb");
    }
    public function get_patient($patient_id){
        $collection = $this->db->selectCollection('patient_mapping');
        $condition = array(
            "patient_random" => $patient_id,
        ); 
        $data = $collection->find($condition, array('first_name','last_name'));
        $data = iterator_to_array($data);
        
        foreach($data as $val){
            $first_name =  $val['first_name'];
            $last_name =  $val['last_name'];
        }
        $fullname =  $first_name." ". $last_name;
        
        return $fullname;
    }
    public function get_doctor($doctor_id){
        $collection = $this->db->selectCollection('users');
        $condition = array(
            "user_id" => $doctor_id,
        ); 
        $data = $collection->find($condition, array('first_name','last_name'));
        $data = iterator_to_array($data);
        
        foreach($data as $val){
            $first_name =  $val['first_name'];
            $last_name =  $val['last_name'];
        }
         $fullname =  $first_name." ". $last_name;
        
        return $fullname;
    }
    public function get_patient_doctor($user_login){
        $collection = $this->db->selectCollection('patient_auth');
            $condition = array(
                "user_id" => $user_login,
                "status" => "0",
            ); 
        $data = $collection->find($condition, array('transfer_patient_id','doctor_transfer'));
        $data = iterator_to_array($data);
        $a = array();
        foreach($data as $val){
            $a[] = array(
                'doctor_transfer' => $val['doctor_transfer'],
                'transfer_patient_id' => $val['transfer_patient_id'],
                'patient_name' => $this->get_patient($val['transfer_patient_id']),
                'doctor_name' => $this->get_doctor($val['doctor_transfer']),
            );
        }
        return $a;
        
    }
    public function insert_transfer($data){
        $collection = $this->db->selectCollection("patient_auth");
        $check_data = $collection->find($data);
        $check_data = iterator_to_array($check_data);
        if(count($check_data) == 0){
            $collection->insert($data);
        }
        
    }
    public function get_user_by_token($token){
        $collection = $this->db->selectCollection("token");
        $condition = array(
            'token' => $token,
            );
        $record = $collection->find($condition, array('user_id'));
        $record = iterator_to_array($record);
        foreach($record as $val){
            $user_id = $val['user_id'];
        }
       
        return $user_id;
    }
    public function generate_token_user($user_login)
    {
            $collection = $this->db->selectCollection('token');
            $id_name = 'users';
            $table = 'counters_token';
            $token = $this->counter_model->update_ai($id_name, $table);
            $data = array(
                'user_id' => $user_login,
                'token' => (string)$token
            );
            $collection->insert($data);
            return $token;

    }
    public function save_status($patient_id, $user_login){
        $collection = $this->db->selectCollection('patient_auth');
        $condition = array(
             'owner' => $patient_id,
             'requester' => $user_login,
         );
         $record = $collection->find($condition);
         $record = iterator_to_array($record);
         if(count($record) > 0){
             $document = array(
                 'owner' => $patient_id,
                 'requester' => $user_login,
                 'status' => "0"
             );
             $collection->update(
                $document,
                array('$set' =>array(
                    'status' => "1"
                ))
             );
         }
         return count($record);
    }
    public function save_status_request($user_login, $doctor_id){
        $collection = $this->db->selectCollection('patient_auth');
        $condition = array(
             'owner' => $user_login,
             'requester' => $doctor_id,
         );
         $record = $collection->find($condition);
         $record = iterator_to_array($record);
         if(count($record) == 0){
             $document = array(
                 'owner' => $user_login,
                 'requester' => $doctor_id,
                 'status' => "0"
             );
             $collection->insert($document);
         }
    }
    public function check_data_insert($data){
        $collection = $this->db->selectCollection('patient_auth');
        
        $record = $collection->find($data);
        $record = iterator_to_array($record);
        
        return $record;
    }
    public function check_token($token){
        $collection = $this->db->selectCollection('token');
        $condition = array(
            'token' => $token,
        );
        $record = $collection->find($condition);
        $record = iterator_to_array($record);
        
        return $record;
    }
    public function generate_token_doctor($user_login)
    {
            $collection = $this->db->selectCollection('token');
            $id_name = 'users';
            $table = 'counters_token';
            $token = $this->counter_model->update_ai($id_name, $table);
            $data = array(
                'user_id' => $user_login,
                'token' => (string)$token
            );
            $collection->insert($data);
            
            return $token;

    }
}
